'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { desc = parent = getter = undefined; _again = false; var object = _x3,
    property = _x4,
    receiver = _x5; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _eventemitter3 = require('eventemitter3');

var _eventemitter32 = _interopRequireDefault(_eventemitter3);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

/**
 * @class Store
 * @extends EventEmitter
 */

var Store = (function (_EventEmitter) {

    /**
     * Constructor
     * @return {Store}
     */

    function Store() {
        _classCallCheck(this, Store);

        _get(Object.getPrototypeOf(Store.prototype), 'constructor', this).call(this);
        // Set initial state on store
        var initialState = this.getInitialState();
        this.setState(initialState, { silent: true });
    }

    _inherits(Store, _EventEmitter);

    _createClass(Store, [{
        key: 'getInitialState',

        /**
         * Default initial state getter
         * @return {Object}
         */
        value: function getInitialState() {
            return {};
        }
    }, {
        key: 'getEmptyState',

        /**
         * Default empty state getter
         * Returns a plain JavaScript object by default
         * Implement `getStateClass` to use a custom class for your state
         * @return {[type]} [description]
         */
        value: function getEmptyState() {
            if (typeof this.getStateClass === 'function') {
                var StateClass = this.getStateClass();
                return new StateClass();
            }
            return {};
        }
    }, {
        key: 'getState',

        /**
         * Returns the state
         * @return {Object} The state object
         */
        value: function getState() {
            return this.state;
        }
    }, {
        key: 'getStateAsObject',

        /**
         * Returns the state as plain JavaScript object
         * @return {Object}
         */
        value: function getStateAsObject() {
            return this.state;
        }
    }, {
        key: 'setState',

        /**
         * Set state
         * @param {Object} state State object
         * @param {Object} options
         * @param {Boolean} options.silent Does not emit change event when true
         * @param {Boolean} options.replace Does replace the current state when true
         */
        value: function setState(state) {
            var options = arguments[1] === undefined ? {} : arguments[1];

            if (this._isSettingState) {
                throw new Error('Cannot set state while setting state');
            }

            this._isSettingState = true;

            var silent = options.silent;
            var replace = options.replace;

            var prevState = this._isHandlingAction ? this._pendingState : this.state;
            if (!prevState || replace === true) {
                prevState = this.getEmptyState();
            }

            var nextState = this.assignState(prevState, state, options);

            if (this._isHandlingAction) {
                this._pendingState = nextState;
                if (silent !== true) this._emitChangeAfterHandlingAction = true;
            } else {
                this.state = nextState;
                if (silent !== true) this.emit('change', this.state);
            }

            this._isSettingState = false;
        }
    }, {
        key: 'replaceState',

        /**
         * Replace state with passed state
         * @param  {Object} state
         * @param  {Object} options
         * @return {void}
         */
        value: function replaceState(state) {
            var options = arguments[1] === undefined ? {} : arguments[1];

            options = _objectAssign2['default']({}, options, { replace: true });
            return this.setState(state, options);
        }
    }, {
        key: 'assignState',

        /**
         * Assign nextState to previousState
         * @param  {Object} prevState
         * @param  {Object} nextState
         * @return {Object}
         */
        value: function assignState(prevState, nextState, options) {
            return _objectAssign2['default']({}, prevState, nextState);
        }
    }, {
        key: 'handleAction',

        /**
         * Register an action handler
         * @param  {String}   id      Id of the action (e.g. 'todos.create')
         * @param  {Function} handler Action handler
         * @return {void}
         */
        value: function handleAction(id, handler) {
            if (!this._handlers) this._handlers = {};

            if (typeof handler !== 'function') {
                throw new Error('Handler for action ' + id + ' is not a function. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }
            if (!this._actionIdExists(id)) {
                throw new Error('Action ' + id + ' does not exist. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }
            if (this._handlers[id]) {
                throw new Error('Handler for action ' + id + ' is already registered. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }

            this._handlers[id] = this._invokeActionHandler.bind(this, handler);
        }
    }, {
        key: '_invokeActionHandler',

        /**
         * Internal method to invoke an action handler
         * @param  {Function}  handler
         * @param  {...}       args
         * @return {void}
         */
        value: function _invokeActionHandler(handler) {
            for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = arguments[_key];
            }

            this._isHandlingAction = true;
            this._pendingState = this.state;
            this._emitChangeAfterHandlingAction = false;

            try {
                handler.call.apply(handler, [this].concat(args));
            } finally {
                this.state = this._pendingState;
                this._pendingState = undefined;

                if (this._emitChangeAfterHandlingAction === true) {
                    this.emit('change', this.state);
                }
            }

            this._emitChangeAfterHandlingAction = false;
            this._isHandlingAction = false;
        }
    }, {
        key: 'stopHandleAction',

        /**
         * Unregister an action handler
         * @param  {String} id  Id of the action (e.g. 'todos.create')
         * @return {void}
         */
        value: function stopHandleAction(id) {
            if (!id || !this._handlers || !this._handlers[id]) return;
            this._handlers[id] = undefined;
        }
    }, {
        key: '_actionIdExists',

        /**
         * Check if action id exists
         * @return {Boolean}
         */
        value: function _actionIdExists(id) {
            // This method will be overriden by the dispatcher.
            // When testing stores without the dispatcher, always return true
            return true;
        }
    }]);

    return Store;
})(_eventemitter32['default']);

exports['default'] = Store;
module.exports = exports['default'];