'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x7, _x8, _x9) { var _again = true; _function: while (_again) { desc = parent = getter = undefined; _again = false; var object = _x7,
    property = _x8,
    receiver = _x9; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x7 = parent; _x8 = property; _x9 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCloneWithProps = require('react/addons/cloneWithProps');

var _reactAddonsCloneWithProps2 = _interopRequireDefault(_reactAddonsCloneWithProps);

var _Flux = require('../Flux');

var _Flux2 = _interopRequireDefault(_Flux);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

/**
 * @class FluxComponent
 * Note: FluxComponent is largely taken from Flummox (https://github.com/acdlite/flummox)
 * Andrew Clark, @acdlite, MIT License
 */

var FluxComponent = (function (_React$Component) {
    function FluxComponent(props, context) {
        _classCallCheck(this, FluxComponent);

        _get(Object.getPrototypeOf(FluxComponent.prototype), 'constructor', this).call(this, props, context);

        this.stateGetters = [];
        this.listeners = {};
        this.flux = this.getFlux();

        this.state = this.connect(props.stores, props.stateGetter);

        this.wrapChild = this.wrapChild.bind(this);
    }

    _inherits(FluxComponent, _React$Component);

    _createClass(FluxComponent, [{
        key: 'wrapChild',
        value: function wrapChild(child) {
            var actions = this.collectActions(this.props.actions, this.props.actionsGetter);
            var props = _objectAssign2['default']({}, this.state, actions);
            // Using deprecated cloneWithProps. With cloneElement, flux would be undefined
            // https://github.com/facebook/react/issues/3392
            return _reactAddonsCloneWithProps2['default'](child, props);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props;
            var children = _props.children;
            var render = _props.render;
            var actions = _props.actions;
            var actionsGetter = _props.actionsGetter;

            if (typeof render === 'function') {
                return render(this.state, this.collectActions(actions, actionsGetter), this.getFlux());
            }

            if (!children) return null;

            if (!Array.isArray(children)) {
                var child = children;
                return this.wrapChild(child);
            } else {
                return _react2['default'].createElement(
                    'span',
                    null,
                    _react2['default'].Children.map(children, this.wrapChild)
                );
            }
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            var flux = this.getFlux();
            if (!flux) return {};
            return { flux: flux };
        }
    }, {
        key: 'getFlux',
        value: function getFlux() {
            return this.props.flux || this.context.flux;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            var flux = this.getFlux();

            for (var key in this.listeners) {
                if (!this.listeners.hasOwnProperty(key)) continue;

                var store = flux.stores[key];
                if (typeof store === 'undefined') continue;

                var listener = this.listeners[key];

                store.removeListener('change', listener);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.updateStores(nextProps);
        }
    }, {
        key: 'updateStores',
        value: function updateStores() {
            var props = arguments[0] === undefined ? this.props : arguments[0];

            var state = this.getStoreState(props);
            this.setState(state);
        }
    }, {
        key: 'getStoreState',
        value: function getStoreState() {
            var props = arguments[0] === undefined ? this.props : arguments[0];

            return this.stateGetters.reduce(function (result, stateGetter) {
                var getter = stateGetter.getter;
                var stores = stateGetter.stores;

                var stateFromStores = getter(stores, props);
                return _objectAssign2['default'](result, stateFromStores);
            }, {});
        }
    }, {
        key: 'connect',
        value: function connect() {
            var _this2 = this;

            var stateGetterMap = arguments[0] === undefined ? {} : arguments[0];
            var stateGetter = arguments[1] === undefined ? null : arguments[1];

            var flux = this.getFlux();

            function getStore(key) {
                var store = flux.stores[key];

                if (typeof store === 'undefined') {
                    throw new Error('Store with key \'' + key + '\' does not exist.' + 'Attempted to connect to store in FluxComponent');
                }
                return store;
            }

            if (typeof stateGetterMap === 'string') {
                var key = stateGetterMap;
                var store = getStore(key);
                var getter = createGetter(stateGetter, defaultStateGetter);

                this.stateGetters.push({ stores: store, getter: getter });
                var listener = createStoreListener(this, store, getter);

                store.addListener('change', listener);
                this.listeners[key] = listener;
            } else if (Array.isArray(stateGetterMap)) {
                (function () {
                    var stores = stateGetterMap.map(getStore);
                    var getter = createGetter(stateGetter, defaultReduceStateGetter);

                    _this2.stateGetters.push({ stores: stores, getter: getter });
                    var listener = createStoreListener(_this2, stores, getter);

                    stateGetterMap.forEach(function (key, index) {
                        var store = stores[index];
                        store.addListener('change', listener);
                        _this2.listeners[key] = listener;
                    });
                })();
            } else {
                for (var key in stateGetterMap) {
                    var store = getStore(key);
                    var getter = createGetter(stateGetterMap[key], defaultStateGetter);

                    this.stateGetters.push({ stores: store, getter: getter });
                    var listener = createStoreListener(this, store, getter);

                    store.addListener('change', listener);
                    this.listeners[key] = listener;
                }
            }

            return this.getStoreState();
        }
    }, {
        key: 'collectActions',
        value: function collectActions() {
            var actionMap = arguments[0] === undefined ? {} : arguments[0];
            var actionGetter = arguments[1] === undefined ? null : arguments[1];

            if (typeof actionMap === 'undefined') return {};

            var flux = this.getFlux();

            function getActions(key) {
                var actions = flux.actions[key];

                if (typeof actions === 'undefined') {
                    throw new Error('Actions with key \'' + key + '\' do not exist.' + 'Attempted to get actions in FluxComponent');
                }
                return actions;
            }

            var collectedActions = {};

            if (typeof actionMap === 'string') {
                var key = actionMap;
                var actions = getActions(key);
                var getter = createGetter(actionGetter, defaultActionGetter);

                _objectAssign2['default'](collectedActions, getter(actions));
            } else if (Array.isArray(actionMap)) {
                var actions = actionMap.map(getActions);
                var getter = createGetter(actionGetter, defaultReduceActionGetter);

                _objectAssign2['default'](collectedActions, getter(actions));
            } else {
                for (var key in actionMap) {
                    var actions = getActions(key);
                    var getter = createGetter(actionMap[key], defaultActionGetter);

                    _objectAssign2['default'](collectedActions, getter(actions));
                }
            }

            return collectedActions;
        }
    }]);

    return FluxComponent;
})(_react2['default'].Component);

FluxComponent.contextTypes = {
    flux: _react.PropTypes.instanceOf(_Flux2['default']) };

FluxComponent.childContextTypes = {
    flux: _react.PropTypes.instanceOf(_Flux2['default']) };

FluxComponent.propTypes = {
    stores: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.arrayOf(_react.PropTypes.string), _react.PropTypes.object]),
    actions: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.arrayOf(_react.PropTypes.string), _react.PropTypes.object]),
    flux: _react.PropTypes.instanceOf(_Flux2['default']),
    stateGetter: _react2['default'].PropTypes.func,
    actionsGetter: _react2['default'].PropTypes.func,
    render: _react2['default'].PropTypes.func
};

function createStoreListener(component, store, storeStateGetter) {
    return (function () {
        var state = storeStateGetter(store, this.props);
        this.setState(state);
    }).bind(component);
}

function createGetter(value, defaultGetter) {
    if (typeof value !== 'function') {
        return defaultGetter;
    } else {
        return value;
    }
}

function defaultStateGetter(store) {
    return store.getStateAsObject();
}

function _ref(result, store) {
    _objectAssign2['default'](result, store.getStateAsObject());
}

function defaultReduceStateGetter(stores) {
    return stores.reduce(_ref, {});
}

function defaultActionGetter(actions) {
    return actions;
}

function _ref2(result, _actions) {
    _objectAssign2['default'](result, _actions.getStateAsObject());
}

function defaultReduceActionGetter(actions) {
    return actions.reduce(_ref2, {});
}

exports['default'] = FluxComponent;
module.exports = exports['default'];